from CvPythonExtensions import *

gc = CyGlobalContext()

class FarmersEventManager:
	def __init__(self, eventManager):
		eventManager.addEventHandler("BeginGameTurn", self.onBeginGameTurn)

	def onBeginGameTurn(self, argsList):
		'Called at the beginning of the end of each turn'
		iGameTurn = argsList[0]

		for i in range(CyMap().numPlots()):
			pPlot = CyMap().plotByIndex(i)
			if pPlot.getTeam() >= 0 and pPlot.getBonusType(-1) < 0 and pPlot.isBeingWorked():
				impType = pPlot.getImprovementType()

				## Code That Determines What Resource Should Be Placed
				if impType is gc.getInfoTypeForString("IMPROVEMENT_FARM"):
					iBonus = gc.getInfoTypeForString("BONUS_CORN")
					if gc.getTeam(pPlot.getTeam()).isHasTech(gc.getBonusInfo(iBonus).getTechReveal()):
						if CyGame().getSorenRandNum(1000, "Placing Bonus") == 0 and gc.getPlayer(pPlot.getOwner()).getNumAvailableBonuses(iBonus) > 0:
							pPlot.setBonusType(iBonus)
							pCity = CyMap().findCity(pPlot.getX(), pPlot.getY(), pPlot.getOwner(), pPlot.getTeam(), False, False, -1, -1, CyCity())
							CyInterface().addMessage(pPlot.getOwner(), False, gc.getDefineINT("EVENT_MESSAGE_TIME"), 'Corn has been discovered near %s' %(pCity.getName()), "AS2D_DISCOVERBONUS", InterfaceMessageTypes.MESSAGE_TYPE_MINOR_EVENT, gc.getBonusInfo(iBonus).getButton(), gc.getInfoTypeForString("COLOR_WHITE"), pPlot.getX(), pPlot.getY(), True, True)

				if impType is gc.getInfoTypeForString("IMPROVEMENT_FARM"):
					iBonus = gc.getInfoTypeForString("BONUS_WHEAT")
					if gc.getTeam(pPlot.getTeam()).isHasTech(gc.getBonusInfo(iBonus).getTechReveal()):
						if CyGame().getSorenRandNum(1000, "Placing Bonus") == 0 and gc.getPlayer(pPlot.getOwner()).getNumAvailableBonuses(iBonus) > 0:
							pPlot.setBonusType(iBonus)
							pCity = CyMap().findCity(pPlot.getX(), pPlot.getY(), pPlot.getOwner(), pPlot.getTeam(), False, False, -1, -1, CyCity())
							CyInterface().addMessage(pPlot.getOwner(), False, gc.getDefineINT("EVENT_MESSAGE_TIME"), 'Corn has been discovered near %s' %(pCity.getName()), "AS2D_DISCOVERBONUS", InterfaceMessageTypes.MESSAGE_TYPE_MINOR_EVENT, gc.getBonusInfo(iBonus).getButton(), gc.getInfoTypeForString("COLOR_WHITE"), pPlot.getX(), pPlot.getY(), True, True)

				if impType is gc.getInfoTypeForString("IMPROVEMENT_FARM"):
					iBonus = gc.getInfoTypeForString("BONUS_RICE")
					if gc.getTeam(pPlot.getTeam()).isHasTech(gc.getBonusInfo(iBonus).getTechReveal()):
						if CyGame().getSorenRandNum(1000, "Placing Bonus") == 0 and gc.getPlayer(pPlot.getOwner()).getNumAvailableBonuses(iBonus) > 0:
							pPlot.setBonusType(iBonus)
							pCity = CyMap().findCity(pPlot.getX(), pPlot.getY(), pPlot.getOwner(), pPlot.getTeam(), False, False, -1, -1, CyCity())
							CyInterface().addMessage(pPlot.getOwner(), False, gc.getDefineINT("EVENT_MESSAGE_TIME"), 'Corn has been discovered near %s' %(pCity.getName()), "AS2D_DISCOVERBONUS", InterfaceMessageTypes.MESSAGE_TYPE_MINOR_EVENT, gc.getBonusInfo(iBonus).getButton(), gc.getInfoTypeForString("COLOR_WHITE"), pPlot.getX(), pPlot.getY(), True, True)